-- iTar.applescript
-- iTar
-- a GNU tar frontend for noobs
--  Created by hany on 05/11/06.
--  Copyright 2006 hanynet.com. All rights reserved.

property tarOptions : missing value
property tarFormat : missing value

on drop theObject drag info dragInfo
	-- Get a list of the data types on the pasteboard
	set dataTypes to types of pasteboard of dragInfo
	if "file names" is in dataTypes then
		-- This is a mechanism to tell the pasteboard which type of data we want when we access the "contents" of the pasteboard.
		set preferred type of pasteboard of dragInfo to "file names"
		-- Get the list of files dropped on the object form the pasteboard
		set thePaths to contents of pasteboard of dragInfo
		set thePath to POSIX path of thePaths
		set theDirName to do shell script "echo \"" & thePath & "\" | sed -e 's/[^\\/]*$//' "
		set theFile to do shell script "basename \"" & thePath & "\""
		-- check compression option
		set compType to the title of popup button 1 of window 1
		if compType = "gzip" then
			set tarOptions to "z"
			set theExt to ".tar.gz"
		else if compType = "bzip2" then
			set tarOptions to "j"
			set theExt to ".tar.bz2"
		else if compType = "Z Unix compress" then
			set tarOptions to "Z"
			set theExt to ".tar.Z"
		else
			set tarOptions to ""
			set theExt to ".tar"
		end if
		-- check tar archive format
		set tform to the current row of matrix "format" of window "options"
		if tform is equal to "1" as number then
			set tarFormat to " --format=gnu "
		else if tform is equal to "2" as number then
			set tarFormat to " --format=oldgnu "
		else if tform is equal to "3" as number then
			set tarFormat to " --format=v7 "
		else if tform is equal to "4" as number then
			set tarFormat to " --format=ustar "
		else if tform is equal to "5" as number then
			set tarFormat to " --format=posix "
		end if
		-- do it
		set the visible of progress indicator "wheel" of window 1 to true as boolean
		tell progress indicator "wheel" of window 1 to start
		do shell script "cd \"" & theDirName & "\" ; tar" & tarFormat & "-" & tarOptions & "cf \"" & theFile & theExt & "\" \"" & theFile & "\""
		set the visible of progress indicator "wheel" of window 1 to false as boolean
		tell progress indicator "wheel" of window 1 to stop
		-- say "mooo" -- lame
		set preferred type of pasteboard of dragInfo to ""
	end if
end drop


-- DROP DATATYPES

on awake from nib theObject
	tell theObject to register drag types {"image", "pict image", "file names", "color", "string"}
end awake from nib

on conclude drop theObject drag info dragInfo
	-- foo
end conclude drop

-- QUIT 

on should quit after last window closed theObject
	quit
end should quit after last window closed

-- click handler

on clicked theObject
	if the name of theObject is "options" then
		display window "options" attached to window "main"
		
	else if the name of theObject is "close" then
		close panel (window of theObject)
	end if
	
end clicked
























-- by hany@hanynet.com - 5 novembre 2006







